# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from microstrain_inertial_msgs/HumanReadableStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import microstrain_inertial_msgs.msg
import std_msgs.msg

class HumanReadableStatus(genpy.Message):
  _md5sum = "a6d2bd6f851d3b79d0fd4e13b7b28292"
  _type = "microstrain_inertial_msgs/HumanReadableStatus"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Convenience message to contain some useful device information
#
# This is a combination of several different messages to allow for an easy view of the device status.
# For more detailed information on the device status, see the messages mentioned in the field definitions below.
#
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# NOTE: This is meant as a useful tool for checking general status of the device by a human.
#       This interface may change without a major version upgrade.
#       It is STRONGLY encouraged to not use this to actually control real logic.
#       For that, we would recommend looking at the other messages mentioned in this one
#       as well as the uncertainty for measurements
# !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

# Header containing the time at which this message was populated
#   header.frame_id will contain the frame ID of the IMU
std_msgs/Header header

# Device information. This information will be read when the node first activates.
# To force an update of this information (shouldn't change during runtime), call the mip/base/get_device_information service
microstrain_inertial_msgs/MipBaseDeviceInfo device_info

# GNSS state. See GNSS_STATE_* for possible values
# This value is computed from many different fields from microstrain_inertial_msgs/MipGnssFixInfo.msg and microstrain_inertial_msgs/MipFilterGnssPositionAidingStatus.msg
string gnss_state

# Dual antenna fix type. See DUAL_ANTENNA_FIX_TYPE_* enums for possble values
# This is identical to fix_type in microstrain_inertial_msgs/MipFilterGnssDualAntennaStatus.msg
string dual_antenna_fix_type

# Device-specific filter state. See filter_state_* enums for possible values
# This is identical to filter_state in microstrain_inertial_msgs/MipFilterStatus.msg represented as a string
string filter_state

# String version of the status_flags field of the MipFilterStatus message. Only active statuses will be in this list
# This is a list of all of the status_flags_* that are true in microstrain_inertial_msgs/MipFilterStatus.msg filtered to only include relevant flags for this type of device
# See STATIS_FLAG_* for possible values that could be in this array
string[] status_flags

# String version of the possible continuous bit fields possibly provided by the device.
# Generally, you want to see nothing populated in this message, but when you do see something, it can be used to diagnose problems with the device.
# This is a parsed out version of microstrain_inertial_msgs/MipSystemBuiltInTest.msg parsed to be accurate for each device
string[] continuous_bit_flags

# Possible value for any field if a devicedoes not support it
string UNSUPPORTED = "Unsupported"

# Possible values for gnss_state
string GNSS_STATE_NO_FIX    = "No Fix"
string GNSS_STATE_3D_FIX    = "3D Fix"
string GNSS_STATE_SBAS      = "SBAS"
string GNSS_STATE_RTK_FLOAT = "RTK Float"
string GNSS_STATE_RTK_FIXED = "RTK Fixed"

# Possible values for dual_antenna_fix_type
string DUAL_ANTENNA_FIX_TYPE_NONE  = "None"
string DUAL_ANTENNA_FIX_TYPE_FLOAT = "Dual Antenna Float"
string DUAL_ANTENNA_FIX_TYPE_FIXED = "Dual Antenna Fixed"

# Possible values for filter_state when the connected device is a philo device (GX5, CX5, CV5, etc)
string FILTER_STATE_GX5_STARTUP            = "Startup"
string FILTER_STATE_GX5_INIT               = "Init"
string FILTER_STATE_GX5_RUN_SOLUTION_VALID = "Solution Valid"
string FILTER_STATE_GX5_RUN_SOLUTION_ERROR = "Solution Error"

# Possible values for filter_state when the connected device is a prospect device (GQ7, CV7, etc)
string FILTER_STATE_GQ7_INIT      = "Init"
string FILTER_STATE_GQ7_VERT_GYRO = "Vertical Gyro"
string FILTER_STATE_GQ7_AHRS      = "AHRS"
string FILTER_STATE_GQ7_FULL_NAV  = "Full Nav"

# Possible values to be stored in status_flags when the connected device is a philo device (GX5, CX5, CV5, etc)
string STATUS_FLAGS_GX5_INIT_NO_ATTITUDE                           = "Init No Attitude"
string STATUS_FLAGS_GX5_INIT_NO_POSITION_VELOCITY                  = "Init No Position / Velocity"
string STATUS_FLAGS_GX5_RUN_IMU_UNAVAILABLE                        = "IMU Unavailable"
string STATUS_FLAGS_GX5_RUN_GPS_UNAVAILABLE                        = "GPS Unavailable"
string STATUS_FLAGS_GX5_RUN_MATRIX_SINGULARITY                     = "Matrix Singularity"
string STATUS_FLAGS_GX5_RUN_POSITION_COVARIANCE_WARNING            = "Position Covariance Warning"
string STATUS_FLAGS_GX5_RUN_VELOCITY_COVARIANCE_WARNING            = "Velocity Covariance Warning"
string STATUS_FLAGS_GX5_RUN_ATTITUDE_COVARIANCE_WARNING            = "Attitude Covariance Warning"
string STATUS_FLAGS_GX5_RUN_NAN_IN_SOLUTION_WARNING                = "NaN in Solution"
string STATUS_FLAGS_GX5_RUN_GYRO_BIAS_EST_HIGH_WARNING             = "Gyroscope Bias Estimate High"
string STATUS_FLAGS_GX5_RUN_ACCEL_BIAS_EST_HIGH_WARNING            = "Accelerometer Bias Estimate High"
string STATUS_FLAGS_GX5_RUN_GYRO_SCALE_FACTOR_EST_HIGH_WARNING     = "Gyroscope Scale Factor Estimate High"
string STATUS_FLAGS_GX5_RUN_ACCEL_SCALE_FACTOR_EST_HIGH_WARNING    = "Accelerometer Scal Factor Estimate High"
string STATUS_FLAGS_GX5_RUN_MAG_BIAS_EST_HIGH_WARNING              = "Magnetometer Bias Estimate High"
string STATUS_FLAGS_GX5_RUN_ANT_OFFSET_CORRECTION_EST_HIGH_WARNING = "Antenna Offset Correction Estimate High"
string STATUS_FLAGS_GX5_RUN_MAG_HARD_IRON_EST_HIGH_WARNING         = "Magnetometer Hard Iron Estimate High"
string STATUS_FLAGS_GX5_RUN_MAG_SOFT_IRON_EST_HIGH_WARNING         = "Magnetometer Soft Iron Estimate High"

# Possible values to be stored in status_flags when the connected device is a prospect device (GQ7, CV7, etc)
string STATUS_FLAGS_GQ7_FILTER_CONDITION_STABLE     = "Stable"
string STATUS_FLAGS_GQ7_FILTER_CONDITION_CONVERGING = "Converging"
string STATUS_FLAGS_GQ7_FILTER_CONDITION_UNSTABLE   = "Unstable"
string STATUS_FLAGS_GQ7_ROLL_PITCH_WARNING          = "Roll / Pitch Warning"
string STATUS_FLAGS_GQ7_HEADING_WARNING             = "Heading Warning"
string STATUS_FLAGS_GQ7_POSITION_WARNING            = "Position Warning"
string STATUS_FLAGS_GQ7_VELOCITY_WARNING            = "Velocity Warning"
string STATUS_FLAGS_GQ7_IMU_BIAS_WARNING            = "IMU Bias Warning"
string STATUS_FLAGS_GQ7_GNSS_CLK_WARNING            = "GNSS Clock Warning"
string STATUS_FLAGS_GQ7_ANTENNA_LEVER_ARM_WARNING   = "Antenna Lever Arm Warning"
string STATUS_FLAGS_GQ7_MOUNTING_TRANSFORM_WARNING  = "Mounting Transform Warning"
string STATUS_FLAGS_GQ7_TIME_SYNC_WARNING           = "Time Sync Warning"
string STATUS_FLAGS_GQ7_SOLUTION_ERROR              = "Solution Error"

# Possible values to be stored in continuous_bit_flags when the connected device is a GQ7
# See https://files.microstrain.com/GQ7+User+Manual/user_manual_content/additional_features/Built-in%20Test.htm for more information
string CONTINUOUS_BIT_FLAGS_GQ7_SYSTEM_CLOCK_FAILURE           = "System Clock Failure"
string CONTINUOUS_BIT_FLAGS_GQ7_POWER_FAULT                    = "Power Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_FIRMWARE_FAULT                 = "Firmware Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_TIMING_OVERLOAD                = "Timing Overload"
string CONTINUOUS_BIT_FLAGS_GQ7_BUFFER_OVERRUN                 = "Buffer Overrun"
string CONTINUOUS_BIT_FLAGS_GQ7_IMU_IPC_FAULT                  = "IMU IPC Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_FILTER_IPC_FAULT               = "Filter IPC Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_GNSS_IPC_FAULT                 = "GNSS IPC Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_IMU_CLOCK_FAULT                = "IMU Clock Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_IMU_COMMUNICATION_FAULT        = "IMU Communication Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_IMU_TIMING_OVERRUN             = "IMU Timing Overrun"
string CONTINUOUS_BIT_FLAGS_GQ7_IMU_CALIBRATION_ERROR_ACCEL    = "IMU Calibration Error - Accel"
string CONTINUOUS_BIT_FLAGS_GQ7_IMU_CALIBRATION_ERROR_GYRO     = "IMU Calibration Error - Gyro"
string CONTINUOUS_BIT_FLAGS_GQ7_IMU_CALIBRATION_ERROR_MAG      = "IMU Calibration Error - Mag"
string CONTINUOUS_BIT_FLAGS_GQ7_ACCELEROMETER_GENERAL_FAULT    = "Accelerometer General Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_ACCELEROMETER_OVER_RANGE       = "Accelerometer Over-Range"
string CONTINUOUS_BIT_FLAGS_GQ7_ACCELEROMETER_SELF_TEST_FAIL   = "Accelerometer Self-test Fail"
string CONTINUOUS_BIT_FLAGS_GQ7_GYROSCOPE_GENERAL_FAULT        = "Gyroscope General Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_GYROSCOPE_OVER_RANGE           = "Gyroscope Over-Range"
string CONTINUOUS_BIT_FLAGS_GQ7_GYROSCOPE_SELF_TEST_FAIL       = "Gyroscope Self-test Fail"
string CONTINUOUS_BIT_FLAGS_GQ7_MAGNETOMETER_GENERAL_FAULT     = "Magnetometer General Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_MAGNETOMETER_OVER_RANGE        = "Magnetometer Over-Range"
string CONTINUOUS_BIT_FLAGS_GQ7_MAGNETOMETER_SELF_TEST_FAIL    = "Magnetometer Self-test Fail"
string CONTINUOUS_BIT_FLAGS_GQ7_PRESSURE_SENSOR_GENERAL_FAULT  = "Pressure Sensor General Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_PRESSURE_SENSOR_OVER_RANGE     = "Pressure Sensor Over-Range"
string CONTINUOUS_BIT_FLAGS_GQ7_PRESSURE_SENSOR_SELF_TEST_FAIL = "Pressure Sensor Self-test Fail"
string CONTINUOUS_BIT_FLAGS_GQ7_FILTER_CLOCK_FAULT             = "Filter Clock Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_FILTER_HARDWARE_FAULT          = "Filter Hardware Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_FILTER_TIMING_OVERRUN          = "Filter Timing Overrun"
string CONTINUOUS_BIT_FLAGS_GQ7_FILTER_TIMING_UNDERRUN         = "Filter Timing Underrun"
string CONTINUOUS_BIT_FLAGS_GQ7_FILTER_COMMUNICATION_ERROR     = "Filter Communication Error"
string CONTINUOUS_BIT_FLAGS_GQ7_GNSS_CLOCK_FAULT               = "GNSS Clock Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_GNSS_HARDWARE_FAULT            = "GNSS Hardware Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_GNSS_COMMUNICATION_ERROR       = "GNSS Communication Error"
string CONTINUOUS_BIT_FLAGS_GQ7_GPS_TIME_FAULT                 = "GPS Time Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_GNSS_TIMING_OVERRUN            = "GNSS Timing Overrun"
string CONTINUOUS_BIT_FLAGS_GQ7_GNSS_RECEIVER_1_POWER_FAULT    = "GNSS Receiver 1 Power Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_GNSS_RECEIVER_1_FAULT          = "GNSS Receiver 1 Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_GNSS_ANTENNA_1_SHORTED         = "GNSS Antenna 1 Shorted"
string CONTINUOUS_BIT_FLAGS_GQ7_GNSS_ANTENNA_1_OPEN            = "GNSS Antenna 1 Open"
string CONTINUOUS_BIT_FLAGS_GQ7_GNSS_RECEIVER_1_SOLUTION_FAULT = "GNSS Receiver 1 Solution Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_GNSS_RECEIVER_2_POWER_FAULT    = "GNSS Receiver 2 Power Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_GNSS_RECEIVER_2_FAULT          = "GNSS Receiver 2 Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_GNSS_ANTENNA_2_SHORTED         = "GNSS Antenna 2 Shorted"
string CONTINUOUS_BIT_FLAGS_GQ7_GNSS_ANTENNA_2_OPEN            = "GNSS Antenna 2 Open"
string CONTINUOUS_BIT_FLAGS_GQ7_GNSS_RECEIVER_2_SOLUTION_FAULT = "GNSS Receiver 2 Solution Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_RTCM_COMMUNICATION_FAULT       = "RTCM Communication Fault"
string CONTINUOUS_BIT_FLAGS_GQ7_RTK_DONGLE_FAULT               = "RTK Dongle Fault"

# Possible values to be stored in continuous_bit_flags when the device is a CV7
# See https://files.microstrain.com/CV7+Online/user_manual_content/additional_features/Built-in%20Test.htm?Highlight=built%20in%20test for more information
string CONTINUOUS_BIT_FLAGS_CV7_SYSTEM_CLOCK_FAILURE                = "System Clock Failure"
string CONTINUOUS_BIT_FLAGS_CV7_POWER_FAULT                         = "Power Fault"
string CONTINUOUS_BIT_FLAGS_CV7_FIRMWARE_FAULT                      = "Firmware Fault"
string CONTINUOUS_BIT_FLAGS_CV7_TIMING_OVERLOAD                     = "Timing Overload"
string CONTINUOUS_BIT_FLAGS_CV7_BUFFER_OVERRUN                      = "Buffer Overrun"
string CONTINUOUS_BIT_FLAGS_CV7_IMU_PROCESS_FAULT                   = "IMU Process Fault"
string CONTINUOUS_BIT_FLAGS_CV7_IMU_DATA_RATE_MISMATCH              = "IMU Data Rate Mismatch"
string CONTINUOUS_BIT_FLAGS_CV7_IMU_OVERRUN_DROPPED_DATA            = "IMU Overrun/Dropped Data"
string CONTINUOUS_BIT_FLAGS_CV7_IMU_STUCK                           = "IMU Stuck"
string CONTINUOUS_BIT_FLAGS_CV7_FILTER_PROCESS_FAULT                = "Filter Process Fault"
string CONTINUOUS_BIT_FLAGS_CV7_FILTER_DROPPED_DATA                 = "Filter Dropped Data"
string CONTINUOUS_BIT_FLAGS_CV7_FILTER_RATE_MISMATCH                = "Filter Rate Mismatch"
string CONTINUOUS_BIT_FLAGS_CV7_FILTER_STUCK                        = "Filter Stuck"
string CONTINUOUS_BIT_FLAGS_CV7_IMU_CLOCK_FAULT                     = "IMU Clock Fault"
string CONTINUOUS_BIT_FLAGS_CV7_IMU_COMMUNICATION_FAULT             = "IMU Communication Fault"
string CONTINUOUS_BIT_FLAGS_CV7_IMU_TIMING_OVERRUN                  = "IMU Timing Overrun"
string CONTINUOUS_BIT_FLAGS_CV7_IMU_CALIBRATION_ERROR_ACCELEROMETER = "IMU Calibration Error - Accelerometer"
string CONTINUOUS_BIT_FLAGS_CV7_IMU_CALIBRATION_ERROR_GYROSCOPE     = "IMU Calibration Error - Gyroscope"
string CONTINUOUS_BIT_FLAGS_CV7_IMU_CALIBRATION_ERROR_MAGNETOMETER  = "IMU Calibration Error - Magnetometer"
string CONTINUOUS_BIT_FLAGS_CV7_ACCELEROMETER_GENERAL_FAULT         = "Accelerometer General Fault"
string CONTINUOUS_BIT_FLAGS_CV7_ACCELEROMETER_OVER_RANGE            = "Accelerometer Over-range"
string CONTINUOUS_BIT_FLAGS_CV7_ACCELEROMETER_SELF_TEST_FAIL        = "Accelerometer Self-test Fail"
string CONTINUOUS_BIT_FLAGS_CV7_GYROSCOPE_GENERAL_FAULT             = "Gyroscope General Fault"
string CONTINUOUS_BIT_FLAGS_CV7_GYROSCOPE_OVER_RANGE                = "Gyroscope Over-range"
string CONTINUOUS_BIT_FLAGS_CV7_GYROSCOPE_SELF_TEST_FAIL            = "Gyroscope Self-test Fail"
string CONTINUOUS_BIT_FLAGS_CV7_MAGNETOMETER_GENERAL_FAULT          = "Magnetometer General Fault"
string CONTINUOUS_BIT_FLAGS_CV7_MAGNETOMETER_OVER_RANGE             = "Magnetometer Over-range"
string CONTINUOUS_BIT_FLAGS_CV7_MAGNETOMETER_SELF_TEST_FAIL         = "Magnetometer Self-test Fail"
string CONTINUOUS_BIT_FLAGS_CV7_PRESSURE_SENSOR_GENERAL_FAULT       = "Pressure Sensor General Fault"
string CONTINUOUS_BIT_FLAGS_CV7_PRESSURE_SENSOR_OVER_RANGE          = "Pressure Sensor Over-range"
string CONTINUOUS_BIT_FLAGS_CV7_PRESSURE_SENSOR_SELF_TEST_FAIL      = "Pressure Sensor Self-test Fail"
string CONTINUOUS_BIT_FLAGS_CV7_FACTORY_BITS_INVALID                = "Factory Bits Invalid"
string CONTINUOUS_BIT_FLAGS_CV7_FILTER_FAULT                        = "Filter Fault"
string CONTINUOUS_BIT_FLAGS_CV7_FILTER_TIMING_OVERRUN               = "Filter Timing Overrun"
string CONTINUOUS_BIT_FLAGS_CV7_FILTER_TIMING_UNDERRUN              = "Filter Timing Underrun"
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: microstrain_inertial_msgs/MipBaseDeviceInfo
# Message definition for https://s3.amazonaws.com/files.microstrain.com/GQ7+User+Manual/external_content/dcp/Commands/base_command/data/base_device_info.htm
#   Note: This message will never be published on it's own, only included in other messages.
string firmware_version  # String version of the firmware version on the device
string model_name        # Model name (3DM-GQ7, 3DM-GX5, etc.)
string model_number      # Model number (6284, 6285, etc.)
string serial_number     # Serial number (6284.109766, 6285.13404, etc.)
string lot_number        # Lot number
string device_options    # Device options"""
  # Pseudo-constants
  UNSUPPORTED = r'"Unsupported"'
  GNSS_STATE_NO_FIX = r'"No Fix"'
  GNSS_STATE_3D_FIX = r'"3D Fix"'
  GNSS_STATE_SBAS = r'"SBAS"'
  GNSS_STATE_RTK_FLOAT = r'"RTK Float"'
  GNSS_STATE_RTK_FIXED = r'"RTK Fixed"'
  DUAL_ANTENNA_FIX_TYPE_NONE = r'"None"'
  DUAL_ANTENNA_FIX_TYPE_FLOAT = r'"Dual Antenna Float"'
  DUAL_ANTENNA_FIX_TYPE_FIXED = r'"Dual Antenna Fixed"'
  FILTER_STATE_GX5_STARTUP = r'"Startup"'
  FILTER_STATE_GX5_INIT = r'"Init"'
  FILTER_STATE_GX5_RUN_SOLUTION_VALID = r'"Solution Valid"'
  FILTER_STATE_GX5_RUN_SOLUTION_ERROR = r'"Solution Error"'
  FILTER_STATE_GQ7_INIT = r'"Init"'
  FILTER_STATE_GQ7_VERT_GYRO = r'"Vertical Gyro"'
  FILTER_STATE_GQ7_AHRS = r'"AHRS"'
  FILTER_STATE_GQ7_FULL_NAV = r'"Full Nav"'
  STATUS_FLAGS_GX5_INIT_NO_ATTITUDE = r'"Init No Attitude"'
  STATUS_FLAGS_GX5_INIT_NO_POSITION_VELOCITY = r'"Init No Position / Velocity"'
  STATUS_FLAGS_GX5_RUN_IMU_UNAVAILABLE = r'"IMU Unavailable"'
  STATUS_FLAGS_GX5_RUN_GPS_UNAVAILABLE = r'"GPS Unavailable"'
  STATUS_FLAGS_GX5_RUN_MATRIX_SINGULARITY = r'"Matrix Singularity"'
  STATUS_FLAGS_GX5_RUN_POSITION_COVARIANCE_WARNING = r'"Position Covariance Warning"'
  STATUS_FLAGS_GX5_RUN_VELOCITY_COVARIANCE_WARNING = r'"Velocity Covariance Warning"'
  STATUS_FLAGS_GX5_RUN_ATTITUDE_COVARIANCE_WARNING = r'"Attitude Covariance Warning"'
  STATUS_FLAGS_GX5_RUN_NAN_IN_SOLUTION_WARNING = r'"NaN in Solution"'
  STATUS_FLAGS_GX5_RUN_GYRO_BIAS_EST_HIGH_WARNING = r'"Gyroscope Bias Estimate High"'
  STATUS_FLAGS_GX5_RUN_ACCEL_BIAS_EST_HIGH_WARNING = r'"Accelerometer Bias Estimate High"'
  STATUS_FLAGS_GX5_RUN_GYRO_SCALE_FACTOR_EST_HIGH_WARNING = r'"Gyroscope Scale Factor Estimate High"'
  STATUS_FLAGS_GX5_RUN_ACCEL_SCALE_FACTOR_EST_HIGH_WARNING = r'"Accelerometer Scal Factor Estimate High"'
  STATUS_FLAGS_GX5_RUN_MAG_BIAS_EST_HIGH_WARNING = r'"Magnetometer Bias Estimate High"'
  STATUS_FLAGS_GX5_RUN_ANT_OFFSET_CORRECTION_EST_HIGH_WARNING = r'"Antenna Offset Correction Estimate High"'
  STATUS_FLAGS_GX5_RUN_MAG_HARD_IRON_EST_HIGH_WARNING = r'"Magnetometer Hard Iron Estimate High"'
  STATUS_FLAGS_GX5_RUN_MAG_SOFT_IRON_EST_HIGH_WARNING = r'"Magnetometer Soft Iron Estimate High"'
  STATUS_FLAGS_GQ7_FILTER_CONDITION_STABLE = r'"Stable"'
  STATUS_FLAGS_GQ7_FILTER_CONDITION_CONVERGING = r'"Converging"'
  STATUS_FLAGS_GQ7_FILTER_CONDITION_UNSTABLE = r'"Unstable"'
  STATUS_FLAGS_GQ7_ROLL_PITCH_WARNING = r'"Roll / Pitch Warning"'
  STATUS_FLAGS_GQ7_HEADING_WARNING = r'"Heading Warning"'
  STATUS_FLAGS_GQ7_POSITION_WARNING = r'"Position Warning"'
  STATUS_FLAGS_GQ7_VELOCITY_WARNING = r'"Velocity Warning"'
  STATUS_FLAGS_GQ7_IMU_BIAS_WARNING = r'"IMU Bias Warning"'
  STATUS_FLAGS_GQ7_GNSS_CLK_WARNING = r'"GNSS Clock Warning"'
  STATUS_FLAGS_GQ7_ANTENNA_LEVER_ARM_WARNING = r'"Antenna Lever Arm Warning"'
  STATUS_FLAGS_GQ7_MOUNTING_TRANSFORM_WARNING = r'"Mounting Transform Warning"'
  STATUS_FLAGS_GQ7_TIME_SYNC_WARNING = r'"Time Sync Warning"'
  STATUS_FLAGS_GQ7_SOLUTION_ERROR = r'"Solution Error"'
  CONTINUOUS_BIT_FLAGS_GQ7_SYSTEM_CLOCK_FAILURE = r'"System Clock Failure"'
  CONTINUOUS_BIT_FLAGS_GQ7_POWER_FAULT = r'"Power Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_FIRMWARE_FAULT = r'"Firmware Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_TIMING_OVERLOAD = r'"Timing Overload"'
  CONTINUOUS_BIT_FLAGS_GQ7_BUFFER_OVERRUN = r'"Buffer Overrun"'
  CONTINUOUS_BIT_FLAGS_GQ7_IMU_IPC_FAULT = r'"IMU IPC Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_FILTER_IPC_FAULT = r'"Filter IPC Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_GNSS_IPC_FAULT = r'"GNSS IPC Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_IMU_CLOCK_FAULT = r'"IMU Clock Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_IMU_COMMUNICATION_FAULT = r'"IMU Communication Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_IMU_TIMING_OVERRUN = r'"IMU Timing Overrun"'
  CONTINUOUS_BIT_FLAGS_GQ7_IMU_CALIBRATION_ERROR_ACCEL = r'"IMU Calibration Error - Accel"'
  CONTINUOUS_BIT_FLAGS_GQ7_IMU_CALIBRATION_ERROR_GYRO = r'"IMU Calibration Error - Gyro"'
  CONTINUOUS_BIT_FLAGS_GQ7_IMU_CALIBRATION_ERROR_MAG = r'"IMU Calibration Error - Mag"'
  CONTINUOUS_BIT_FLAGS_GQ7_ACCELEROMETER_GENERAL_FAULT = r'"Accelerometer General Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_ACCELEROMETER_OVER_RANGE = r'"Accelerometer Over-Range"'
  CONTINUOUS_BIT_FLAGS_GQ7_ACCELEROMETER_SELF_TEST_FAIL = r'"Accelerometer Self-test Fail"'
  CONTINUOUS_BIT_FLAGS_GQ7_GYROSCOPE_GENERAL_FAULT = r'"Gyroscope General Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_GYROSCOPE_OVER_RANGE = r'"Gyroscope Over-Range"'
  CONTINUOUS_BIT_FLAGS_GQ7_GYROSCOPE_SELF_TEST_FAIL = r'"Gyroscope Self-test Fail"'
  CONTINUOUS_BIT_FLAGS_GQ7_MAGNETOMETER_GENERAL_FAULT = r'"Magnetometer General Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_MAGNETOMETER_OVER_RANGE = r'"Magnetometer Over-Range"'
  CONTINUOUS_BIT_FLAGS_GQ7_MAGNETOMETER_SELF_TEST_FAIL = r'"Magnetometer Self-test Fail"'
  CONTINUOUS_BIT_FLAGS_GQ7_PRESSURE_SENSOR_GENERAL_FAULT = r'"Pressure Sensor General Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_PRESSURE_SENSOR_OVER_RANGE = r'"Pressure Sensor Over-Range"'
  CONTINUOUS_BIT_FLAGS_GQ7_PRESSURE_SENSOR_SELF_TEST_FAIL = r'"Pressure Sensor Self-test Fail"'
  CONTINUOUS_BIT_FLAGS_GQ7_FILTER_CLOCK_FAULT = r'"Filter Clock Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_FILTER_HARDWARE_FAULT = r'"Filter Hardware Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_FILTER_TIMING_OVERRUN = r'"Filter Timing Overrun"'
  CONTINUOUS_BIT_FLAGS_GQ7_FILTER_TIMING_UNDERRUN = r'"Filter Timing Underrun"'
  CONTINUOUS_BIT_FLAGS_GQ7_FILTER_COMMUNICATION_ERROR = r'"Filter Communication Error"'
  CONTINUOUS_BIT_FLAGS_GQ7_GNSS_CLOCK_FAULT = r'"GNSS Clock Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_GNSS_HARDWARE_FAULT = r'"GNSS Hardware Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_GNSS_COMMUNICATION_ERROR = r'"GNSS Communication Error"'
  CONTINUOUS_BIT_FLAGS_GQ7_GPS_TIME_FAULT = r'"GPS Time Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_GNSS_TIMING_OVERRUN = r'"GNSS Timing Overrun"'
  CONTINUOUS_BIT_FLAGS_GQ7_GNSS_RECEIVER_1_POWER_FAULT = r'"GNSS Receiver 1 Power Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_GNSS_RECEIVER_1_FAULT = r'"GNSS Receiver 1 Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_GNSS_ANTENNA_1_SHORTED = r'"GNSS Antenna 1 Shorted"'
  CONTINUOUS_BIT_FLAGS_GQ7_GNSS_ANTENNA_1_OPEN = r'"GNSS Antenna 1 Open"'
  CONTINUOUS_BIT_FLAGS_GQ7_GNSS_RECEIVER_1_SOLUTION_FAULT = r'"GNSS Receiver 1 Solution Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_GNSS_RECEIVER_2_POWER_FAULT = r'"GNSS Receiver 2 Power Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_GNSS_RECEIVER_2_FAULT = r'"GNSS Receiver 2 Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_GNSS_ANTENNA_2_SHORTED = r'"GNSS Antenna 2 Shorted"'
  CONTINUOUS_BIT_FLAGS_GQ7_GNSS_ANTENNA_2_OPEN = r'"GNSS Antenna 2 Open"'
  CONTINUOUS_BIT_FLAGS_GQ7_GNSS_RECEIVER_2_SOLUTION_FAULT = r'"GNSS Receiver 2 Solution Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_RTCM_COMMUNICATION_FAULT = r'"RTCM Communication Fault"'
  CONTINUOUS_BIT_FLAGS_GQ7_RTK_DONGLE_FAULT = r'"RTK Dongle Fault"'
  CONTINUOUS_BIT_FLAGS_CV7_SYSTEM_CLOCK_FAILURE = r'"System Clock Failure"'
  CONTINUOUS_BIT_FLAGS_CV7_POWER_FAULT = r'"Power Fault"'
  CONTINUOUS_BIT_FLAGS_CV7_FIRMWARE_FAULT = r'"Firmware Fault"'
  CONTINUOUS_BIT_FLAGS_CV7_TIMING_OVERLOAD = r'"Timing Overload"'
  CONTINUOUS_BIT_FLAGS_CV7_BUFFER_OVERRUN = r'"Buffer Overrun"'
  CONTINUOUS_BIT_FLAGS_CV7_IMU_PROCESS_FAULT = r'"IMU Process Fault"'
  CONTINUOUS_BIT_FLAGS_CV7_IMU_DATA_RATE_MISMATCH = r'"IMU Data Rate Mismatch"'
  CONTINUOUS_BIT_FLAGS_CV7_IMU_OVERRUN_DROPPED_DATA = r'"IMU Overrun/Dropped Data"'
  CONTINUOUS_BIT_FLAGS_CV7_IMU_STUCK = r'"IMU Stuck"'
  CONTINUOUS_BIT_FLAGS_CV7_FILTER_PROCESS_FAULT = r'"Filter Process Fault"'
  CONTINUOUS_BIT_FLAGS_CV7_FILTER_DROPPED_DATA = r'"Filter Dropped Data"'
  CONTINUOUS_BIT_FLAGS_CV7_FILTER_RATE_MISMATCH = r'"Filter Rate Mismatch"'
  CONTINUOUS_BIT_FLAGS_CV7_FILTER_STUCK = r'"Filter Stuck"'
  CONTINUOUS_BIT_FLAGS_CV7_IMU_CLOCK_FAULT = r'"IMU Clock Fault"'
  CONTINUOUS_BIT_FLAGS_CV7_IMU_COMMUNICATION_FAULT = r'"IMU Communication Fault"'
  CONTINUOUS_BIT_FLAGS_CV7_IMU_TIMING_OVERRUN = r'"IMU Timing Overrun"'
  CONTINUOUS_BIT_FLAGS_CV7_IMU_CALIBRATION_ERROR_ACCELEROMETER = r'"IMU Calibration Error - Accelerometer"'
  CONTINUOUS_BIT_FLAGS_CV7_IMU_CALIBRATION_ERROR_GYROSCOPE = r'"IMU Calibration Error - Gyroscope"'
  CONTINUOUS_BIT_FLAGS_CV7_IMU_CALIBRATION_ERROR_MAGNETOMETER = r'"IMU Calibration Error - Magnetometer"'
  CONTINUOUS_BIT_FLAGS_CV7_ACCELEROMETER_GENERAL_FAULT = r'"Accelerometer General Fault"'
  CONTINUOUS_BIT_FLAGS_CV7_ACCELEROMETER_OVER_RANGE = r'"Accelerometer Over-range"'
  CONTINUOUS_BIT_FLAGS_CV7_ACCELEROMETER_SELF_TEST_FAIL = r'"Accelerometer Self-test Fail"'
  CONTINUOUS_BIT_FLAGS_CV7_GYROSCOPE_GENERAL_FAULT = r'"Gyroscope General Fault"'
  CONTINUOUS_BIT_FLAGS_CV7_GYROSCOPE_OVER_RANGE = r'"Gyroscope Over-range"'
  CONTINUOUS_BIT_FLAGS_CV7_GYROSCOPE_SELF_TEST_FAIL = r'"Gyroscope Self-test Fail"'
  CONTINUOUS_BIT_FLAGS_CV7_MAGNETOMETER_GENERAL_FAULT = r'"Magnetometer General Fault"'
  CONTINUOUS_BIT_FLAGS_CV7_MAGNETOMETER_OVER_RANGE = r'"Magnetometer Over-range"'
  CONTINUOUS_BIT_FLAGS_CV7_MAGNETOMETER_SELF_TEST_FAIL = r'"Magnetometer Self-test Fail"'
  CONTINUOUS_BIT_FLAGS_CV7_PRESSURE_SENSOR_GENERAL_FAULT = r'"Pressure Sensor General Fault"'
  CONTINUOUS_BIT_FLAGS_CV7_PRESSURE_SENSOR_OVER_RANGE = r'"Pressure Sensor Over-range"'
  CONTINUOUS_BIT_FLAGS_CV7_PRESSURE_SENSOR_SELF_TEST_FAIL = r'"Pressure Sensor Self-test Fail"'
  CONTINUOUS_BIT_FLAGS_CV7_FACTORY_BITS_INVALID = r'"Factory Bits Invalid"'
  CONTINUOUS_BIT_FLAGS_CV7_FILTER_FAULT = r'"Filter Fault"'
  CONTINUOUS_BIT_FLAGS_CV7_FILTER_TIMING_OVERRUN = r'"Filter Timing Overrun"'
  CONTINUOUS_BIT_FLAGS_CV7_FILTER_TIMING_UNDERRUN = r'"Filter Timing Underrun"'

  __slots__ = ['header','device_info','gnss_state','dual_antenna_fix_type','filter_state','status_flags','continuous_bit_flags']
  _slot_types = ['std_msgs/Header','microstrain_inertial_msgs/MipBaseDeviceInfo','string','string','string','string[]','string[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,device_info,gnss_state,dual_antenna_fix_type,filter_state,status_flags,continuous_bit_flags

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(HumanReadableStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.device_info is None:
        self.device_info = microstrain_inertial_msgs.msg.MipBaseDeviceInfo()
      if self.gnss_state is None:
        self.gnss_state = ''
      if self.dual_antenna_fix_type is None:
        self.dual_antenna_fix_type = ''
      if self.filter_state is None:
        self.filter_state = ''
      if self.status_flags is None:
        self.status_flags = []
      if self.continuous_bit_flags is None:
        self.continuous_bit_flags = []
    else:
      self.header = std_msgs.msg.Header()
      self.device_info = microstrain_inertial_msgs.msg.MipBaseDeviceInfo()
      self.gnss_state = ''
      self.dual_antenna_fix_type = ''
      self.filter_state = ''
      self.status_flags = []
      self.continuous_bit_flags = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.device_info.firmware_version
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.device_info.model_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.device_info.model_number
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.device_info.serial_number
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.device_info.lot_number
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.device_info.device_options
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gnss_state
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.dual_antenna_fix_type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.filter_state
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.status_flags)
      buff.write(_struct_I.pack(length))
      for val1 in self.status_flags:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.continuous_bit_flags)
      buff.write(_struct_I.pack(length))
      for val1 in self.continuous_bit_flags:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.device_info is None:
        self.device_info = microstrain_inertial_msgs.msg.MipBaseDeviceInfo()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.device_info.firmware_version = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.device_info.firmware_version = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.device_info.model_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.device_info.model_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.device_info.model_number = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.device_info.model_number = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.device_info.serial_number = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.device_info.serial_number = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.device_info.lot_number = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.device_info.lot_number = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.device_info.device_options = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.device_info.device_options = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gnss_state = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gnss_state = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.dual_antenna_fix_type = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.dual_antenna_fix_type = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.filter_state = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.filter_state = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.status_flags = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.status_flags.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.continuous_bit_flags = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.continuous_bit_flags.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.device_info.firmware_version
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.device_info.model_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.device_info.model_number
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.device_info.serial_number
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.device_info.lot_number
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.device_info.device_options
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gnss_state
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.dual_antenna_fix_type
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.filter_state
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.status_flags)
      buff.write(_struct_I.pack(length))
      for val1 in self.status_flags:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.continuous_bit_flags)
      buff.write(_struct_I.pack(length))
      for val1 in self.continuous_bit_flags:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.device_info is None:
        self.device_info = microstrain_inertial_msgs.msg.MipBaseDeviceInfo()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.device_info.firmware_version = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.device_info.firmware_version = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.device_info.model_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.device_info.model_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.device_info.model_number = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.device_info.model_number = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.device_info.serial_number = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.device_info.serial_number = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.device_info.lot_number = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.device_info.lot_number = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.device_info.device_options = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.device_info.device_options = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gnss_state = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gnss_state = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.dual_antenna_fix_type = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.dual_antenna_fix_type = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.filter_state = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.filter_state = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.status_flags = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.status_flags.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.continuous_bit_flags = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.continuous_bit_flags.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
