# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from microstrain_inertial_msgs/MipGpsTimestamp.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import microstrain_inertial_msgs.msg

class MipGpsTimestamp(genpy.Message):
  _md5sum = "dff12f3cfc94aed05021c19e947f2a66"
  _type = "microstrain_inertial_msgs/MipGpsTimestamp"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Definition of a GPS timestamp.
# For more information see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_gps_timestamp.htm
#   Note: This message will never be published on it's own, only included in other messages

# GPS time of week (seconds)
float64 tow

# GPS Week number since 1980 (weeks)
uint16 week_number

# Valid Flags bitfield
microstrain_inertial_msgs/MipGpsTimestampValidFlags valid_flags
================================================================================
MSG: microstrain_inertial_msgs/MipGpsTimestampValidFlags
# Message definition for the valid_flags field of https://files.microstrain.com/CV7+Online/external_content/dcp/Data/0xff/data/0xd3.htm
#   Note: This message will never be published on it's own, only included in other messages.

# Whole number seconds TOW has been set
bool tow

# Week number has been set
bool week_number

# Both TOW and Week Number have been set
bool time_valid"""
  __slots__ = ['tow','week_number','valid_flags']
  _slot_types = ['float64','uint16','microstrain_inertial_msgs/MipGpsTimestampValidFlags']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       tow,week_number,valid_flags

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MipGpsTimestamp, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.tow is None:
        self.tow = 0.
      if self.week_number is None:
        self.week_number = 0
      if self.valid_flags is None:
        self.valid_flags = microstrain_inertial_msgs.msg.MipGpsTimestampValidFlags()
    else:
      self.tow = 0.
      self.week_number = 0
      self.valid_flags = microstrain_inertial_msgs.msg.MipGpsTimestampValidFlags()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_dH3B().pack(_x.tow, _x.week_number, _x.valid_flags.tow, _x.valid_flags.week_number, _x.valid_flags.time_valid))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.valid_flags is None:
        self.valid_flags = microstrain_inertial_msgs.msg.MipGpsTimestampValidFlags()
      end = 0
      _x = self
      start = end
      end += 13
      (_x.tow, _x.week_number, _x.valid_flags.tow, _x.valid_flags.week_number, _x.valid_flags.time_valid,) = _get_struct_dH3B().unpack(str[start:end])
      self.valid_flags.tow = bool(self.valid_flags.tow)
      self.valid_flags.week_number = bool(self.valid_flags.week_number)
      self.valid_flags.time_valid = bool(self.valid_flags.time_valid)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_dH3B().pack(_x.tow, _x.week_number, _x.valid_flags.tow, _x.valid_flags.week_number, _x.valid_flags.time_valid))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.valid_flags is None:
        self.valid_flags = microstrain_inertial_msgs.msg.MipGpsTimestampValidFlags()
      end = 0
      _x = self
      start = end
      end += 13
      (_x.tow, _x.week_number, _x.valid_flags.tow, _x.valid_flags.week_number, _x.valid_flags.time_valid,) = _get_struct_dH3B().unpack(str[start:end])
      self.valid_flags.tow = bool(self.valid_flags.tow)
      self.valid_flags.week_number = bool(self.valid_flags.week_number)
      self.valid_flags.time_valid = bool(self.valid_flags.time_valid)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_dH3B = None
def _get_struct_dH3B():
    global _struct_dH3B
    if _struct_dH3B is None:
        _struct_dH3B = struct.Struct("<dH3B")
    return _struct_dH3B
